﻿#Region " Imports "
Imports Infragistics.Web.UI.GridControls
Imports Data.Tsql

#End Region
<Serializable()> _
Public Class GridGroupedColumnCollection
    Inherits System.Collections.CollectionBase

#Region "Constructors"
    Public Sub New()
        MyBase.New()
    End Sub

    Public Sub New(ByVal groupedColumns As Infragistics.Web.UI.GridControls.GroupedColumns)
        MyBase.new()
        Me.Parse(groupedColumns)
    End Sub

    Public Sub New(ByVal strGroupBy As String)
        MyBase.New()
        Me.Parse(strGroupBy)
    End Sub
#End Region

#Region "Properties"
    Public ReadOnly Property Item(ByVal nIndex As Integer) As GridGroupedColumn
        Get
            Return CType(Me.List.Item(nIndex), GridGroupedColumn)
        End Get
    End Property

    Public ReadOnly Property Items() As GridGroupedColumnCollection
        Get
            Return Me
        End Get
    End Property
#End Region

#Region "Methods"
    Public Sub Add(ByVal scGroupBy As GridGroupedColumn)
        Me.List.Add(scGroupBy)
    End Sub

    Public Function Contains(ByVal scGroupBy As GridGroupedColumn) As Boolean
        Return Me.List.Contains(scGroupBy)
    End Function

    Public Sub CopyTo(ByVal arrGroupBy() As GridGroupedColumn, ByVal nIndex As Integer)
        Me.CopyTo(arrGroupBy, nIndex)
    End Sub

    Public Sub Insert(ByVal nIndex As Integer, ByVal scGroupBy As GridGroupedColumn)
        Me.List.Insert(nIndex, scGroupBy)
    End Sub

    Public Function IndexOf(ByVal scGroupBy As GridGroupedColumn) As Integer
        Return Me.List.IndexOf(scGroupBy)
    End Function

    Public Sub Parse(ByVal GroupedColumns As Infragistics.Web.UI.GridControls.GroupedColumns)
        If (GroupedColumns Is Nothing) Then
            Exit Sub
        End If

        Me.Clear()

        If (GroupedColumns.Count = 0) Then
            Exit Sub
        End If
        For Each grpcolumn As GroupedColumn In GroupedColumns
            Dim scGroupBy As New GridGroupedColumn(grpcolumn)
            Me.Add(scGroupBy)
        Next
    End Sub

    Public Sub Parse(ByVal strGroupBy As String)
        If (strGroupBy Is Nothing) Then
            Exit Sub
        End If

        Me.Clear()

        If (strGroupBy.Length = 0) Then
            Exit Sub
        End If

        Dim strParts() As String = strGroupBy.Split(Keyword.FieldDelimiter)
        Dim nPart As Integer
        For nPart = 0 To strParts.Length - 1

            Dim ggColumn As New GridGroupedColumn(strParts(nPart).Trim())
            Me.Add(ggColumn)
        Next
    End Sub

    Public Sub Remove(ByVal nIndex As Integer)
        Me.List.RemoveAt(nIndex)
    End Sub
#End Region
End Class