﻿Imports Data.Tsql
Imports System.Data.Odbc

<Serializable()> _
Public Class GroupByCollection
    Inherits System.Collections.CollectionBase

#Region "Constructors"
    Public Sub New()
        MyBase.New()
    End Sub

    Public Sub New(ByVal strGroupBy As String)
        MyBase.New()
        Me.Parse(strGroupBy)
    End Sub
#End Region

#Region "Properties"
    Public ReadOnly Property Item(ByVal nIndex As Integer) As GroupBy
        Get
            Return CType(Me.List.Item(nIndex), GroupBy)
        End Get
    End Property
#End Region

#Region "Methods"
    Public Sub Add(ByVal scGroupBy As GroupBy)
        Me.List.Add(scGroupBy)
    End Sub

    Public Function Contains(ByVal scGroupBy As GroupBy) As Boolean
        Return Me.List.Contains(scGroupBy)
    End Function

    Public Sub CopyTo(ByVal arrGroupBy() As GroupBy, ByVal nIndex As Integer)
        Me.CopyTo(arrGroupBy, nIndex)
    End Sub

    Public Sub Insert(ByVal nIndex As Integer, ByVal scGroupBy As GroupBy)
        Me.List.Insert(nIndex, scGroupBy)
    End Sub

    Public Sub FromSql(ByVal strGroupBy As String)
        Me.Clear()
        If (strGroupBy Is Nothing) Then
            Exit Sub
        End If

        If (strGroupBy.Length = 0) Then
            Exit Sub
        End If

        Dim strParts() As String = strGroupBy.Split(Keyword.FieldDelimiter)
        Dim nPart As Integer
        For nPart = 0 To strParts.Length - 1
            Dim scGroupBy As New GroupBy
            scGroupBy.FromSql(strParts(nPart))
            Add(scGroupBy)
        Next
    End Sub

    Public Function IndexOf(ByVal scGroupBy As GroupBy) As Integer
        Return Me.List.IndexOf(scGroupBy)
    End Function

    Public Sub Parse(ByVal strGroupBy As String)
        If (strGroupBy Is Nothing) Then
            Exit Sub
        End If

        Me.Clear()

        If (strGroupBy.Length = 0) Then
            Exit Sub
        End If

        Dim strParts() As String = strGroupBy.Split(Keyword.FieldDelimiter)
        Dim nPart As Integer
        For nPart = 0 To strParts.Length - 1

            Dim scGroupBy As New GroupBy(strParts(nPart).Trim())
            Me.Add(scGroupBy)
        Next
    End Sub

    Public Sub Remove(ByVal nIndex As Integer)
        Me.List.RemoveAt(nIndex)
    End Sub

    Public Overrides Function ToString() As String

        Dim strCriteria As String = ""
        Dim strGroupBy As String = ""
        Dim scGroupBy As GroupBy

        For Each scGroupBy In Me.List
            strCriteria = scGroupBy.ToString
            If Not (strCriteria.Length = 0) Then
                If Not (strGroupBy.Length = 0) Then
                    strGroupBy = String.Concat(strGroupBy, Keyword.FieldDelimiter)
                End If
                strGroupBy = String.Concat(strGroupBy, strCriteria)
            End If
        Next
        Return strGroupBy

    End Function

    Public Function ToSql() As String

        Dim strCriteria As String
        Dim strSql As String = Nothing
        Dim scGroupBy As GroupBy

        If (Me.List.Count = 0) Then
            Return String.Empty
        End If

        For Each scGroupBy In Me.List
            strCriteria = scGroupBy.ToSql
            If Not (strCriteria.Length = 0) Then
                If Not (strSql Is Nothing) Then
                    strSql = String.Concat(strSql, Keyword.FieldDelimiter)
                End If
                strSql = String.Concat(strSql, strCriteria)
            End If
        Next
        Return strSql

    End Function

    Public Function ToGroupBySql() As String

        Dim strCriteria As String
        Dim strSql As String = Nothing
        Dim scGroupBy As GroupBy

        If (Me.List.Count = 0) Then
            Return String.Empty
        End If

        For Each scGroupBy In Me.List
            strCriteria = Field.GetQuotedFieldName(scGroupBy.ColumnName)
            If Not (strCriteria.Length = 0) Then
                If Not (strSql Is Nothing) Then
                    strSql = String.Concat(strSql, Keyword.FieldDelimiter)
                End If
                strSql = String.Concat(strSql, strCriteria)
            End If
        Next
        Return strSql

    End Function
#End Region

End Class
